/*  -*- c++ -*-  */
#ifndef ATOMTYPE_H
#define ATOMTYPE_H

#include <string>

#include "Real.h"

namespace ProtoMol {

  //_________________________________________________________________ AtomType
  /**
   * This class contains information common to one type of atom.  This
   * currently only includes the name and mass of the atom type.  The
   * Lennard-Jones parameters are stored in the LennardJonesParameterTable
   * structure.
   */
  struct AtomType {
  
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // Constructors, destructors, assignment
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    AtomType():name(""),mass(0.0),charge(0.0),symbolName("") {}

  
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // My data members
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    std::string name;       ///< The name of this atom type.
    Real mass;              ///< The mass of this atom type.
    Real charge;            ///< The charge of this atom type.
    std::string symbolName; ///< The symbol untity name of this atom type.
  };

}
#endif /* ATOMTYPE_H */
