#include "registerIntegratorExemplars.h"
#include "BBKIntegrator.h"
#include "BSplineMOLLYIntegrator.h"
#include "DMDLeapfrogIntegrator.h"
#include "DihedralHMCIntegrator.h"
#include "DLMCIntegrator.h"
#include "EquilibriumMOLLYIntegrator.h"
#include "HMCIntegrator.h"
#include "ImpulseIntegrator.h"
#include "IntegratorFactory.h"
#include "LangevinImpulseIntegrator.h"
#include "LeapfrogIntegrator.h"
#include "NPTVerletIntegrator.h"
#include "NoseNVTLeapfrogIntegrator.h"
#include "PLeapfrogIntegrator.h"
#include "PaulTrapIntegrator.h"
#include "ShadowHMCIntegrator.h"
#include "UmbrellaIntegrator.h"

#include "Vector.h"

namespace ProtoMol {

  void registerIntegratorExemplars(){
    IntegratorFactory::registerExemplar(new BBKIntegrator());
    IntegratorFactory::registerExemplar(new BSplineMOLLYIntegrator(),Vector<std::string>("HBondMOLLY"));
    IntegratorFactory::registerExemplar(new DMDLeapfrogIntegrator());
    IntegratorFactory::registerExemplar(new DihedralHMCIntegrator());
    IntegratorFactory::registerExemplar(new DLMCIntegrator());
    IntegratorFactory::registerExemplar(new EquilibriumMOLLYIntegrator());
    IntegratorFactory::registerExemplar(new HMCIntegrator());
    IntegratorFactory::registerExemplar(new ImpulseIntegrator());
    IntegratorFactory::registerExemplar(new LangevinImpulseIntegrator());
    IntegratorFactory::registerExemplar(new LeapfrogIntegrator());
    IntegratorFactory::registerExemplar(new NPTVerletIntegrator()/*,Vector<std::string>("NoseNPTLeapfrog")*/);
    IntegratorFactory::registerExemplar(new NoseNVTLeapfrogIntegrator());
    IntegratorFactory::registerExemplar(new PLeapfrogIntegrator());
    IntegratorFactory::registerExemplar(new PaulTrapIntegrator());
    IntegratorFactory::registerExemplar(new ShadowHMCIntegrator());
    IntegratorFactory::registerExemplar(new UmbrellaIntegrator());    
  }
}
