#include "registerOutputExemplars.h"
#include "OutputDCDTrajectory.h"
#include "OutputDiffusion.h"
#include "OutputDihedrals.h"
#include "OutputEnergies.h"
#include "OutputFactory.h"
#include "OutputFinalPDBPos.h"
#include "OutputFinalXYZBinPos.h"
#include "OutputFinalXYZBinVel.h"
#include "OutputFinalXYZPos.h"
#include "OutputFinalXYZVel.h"
#include "OutputMomentum.h"
#include "OutputPDBFramePos.h"
#include "OutputPaulTrap.h"
#include "OutputScreen.h"
#include "OutputTemperatures.h"
#include "OutputXYZTrajectoryForce.h"
#include "OutputXYZTrajectoryPos.h"
#include "OutputXYZTrajectoryVel.h"

namespace ProtoMol {

  void registerOutputExemplars(){
    OutputFactory::registerExemplar(new OutputDCDTrajectory());
    OutputFactory::registerExemplar(new OutputDiffusion());
    OutputFactory::registerExemplar(new OutputDihedrals());
    OutputFactory::registerExemplar(new OutputEnergies());
    OutputFactory::registerExemplar(new OutputFinalXYZBinPos());
    OutputFactory::registerExemplar(new OutputFinalXYZBinVel());
    OutputFactory::registerExemplar(new OutputFinalXYZPos());
    OutputFactory::registerExemplar(new OutputFinalPDBPos());
    OutputFactory::registerExemplar(new OutputFinalXYZVel());
    OutputFactory::registerExemplar(new OutputMomentum());
    OutputFactory::registerExemplar(new OutputPDBFramePos());
    OutputFactory::registerExemplar(new OutputPaulTrap());
    OutputFactory::registerExemplar(new OutputScreen());
    OutputFactory::registerExemplar(new OutputTemperatures());
    OutputFactory::registerExemplar(new OutputXYZTrajectoryForce());
    OutputFactory::registerExemplar(new OutputXYZTrajectoryPos());
    OutputFactory::registerExemplar(new OutputXYZTrajectoryVel());
  }
}
