#include "OutputFile.h"
#include "Configuration.h"

using namespace ProtoMol::Report;

using std::string;

namespace ProtoMol {
  //________________________________________________________ Output
  OutputFile::OutputFile():Output(),myFilename(""){}

  OutputFile::OutputFile(const string& filename, int freq):Output(freq),myFilename(filename){}

  OutputFile::~OutputFile(){
    close();
  }

  bool OutputFile::open(){
    myFile.open(myFilename.c_str(), std::ios::out|std::ios::trunc);
    if(myFile)
      return true;
    else
      return false;
  }

  bool OutputFile::reopen(){
    myFile.open(myFilename.c_str(), std::ios::out |std::ios::app);
    if(myFile)
      return true;
    else
      return false;
  }

  bool OutputFile::close(){
    myFile.close();
    if(myFile)
      return true;
    else
      return false;
  }

  bool OutputFile::reclose(){
    myFile.close();
    if(myFile)
      return true;
    else
      return false;
  }

}
