#include "OutputFinalPDBPos.h"
#include "Configuration.h"
#include "OutputCache.h"
#include "stringutilities.h"
#include "GenericTopology.h"
#include "PDBWriter.h"
using namespace ProtoMol::Report;

using std::string;
using std::vector;

namespace ProtoMol {
  //________________________________________________________ OutputFinalPDBPos
  const string  OutputFinalPDBPos::keyword("finPDBPosFile");

  OutputFinalPDBPos::OutputFinalPDBPos():Output(1),myFilename(""){}

  OutputFinalPDBPos::OutputFinalPDBPos(const string& filename):Output(1),myFilename(filename){}

  void OutputFinalPDBPos::doFinalize(int step){
    PDBWriter writer;
    if(!writer.open(myFilename))
      report << error << "Can't open "<<getId()<<" \'"<<myFilename<<"\'."<<endr;
    writer.setComment("Time : "+toString(myCache->time())+", step : "+toString(step)+".");
    if(!writer.write(*myPositions, myCache->pdb()))
      report << error << "Could not write "<<getId()<<" \'"<<myFilename<<"\'."<<endr;    
  }

  Output* OutputFinalPDBPos::doMake(string&, const vector<Value>& values) const{
    return (new OutputFinalPDBPos(values[0]));
  }

  void OutputFinalPDBPos::getParameters(vector<Parameter> &parameter) const{
    parameter.push_back(Parameter(getId(),Value(myFilename,ConstraintValueType::NotEmpty())));
  }

}
