#include "OutputFinalXYZBinPos.h"
#include "Configuration.h"
#include "GenericTopology.h"
#include "XYZBinWriter.h"
using namespace ProtoMol::Report;

using std::string;
using std::vector;

namespace ProtoMol {
  //________________________________________________________ OutputFinalXYZBinPos
  const string  OutputFinalXYZBinPos::keyword("finXYZBinPosFile");

  OutputFinalXYZBinPos::OutputFinalXYZBinPos():Output(1),myFilename(""){}

  OutputFinalXYZBinPos::OutputFinalXYZBinPos(const string& filename):Output(1),myFilename(filename){}

  void OutputFinalXYZBinPos::doFinalize(int){
    XYZBinWriter writer;
    if(!writer.open(myFilename))
      report << error << "Can't open "<<getId()<<" \'"<<myFilename<<"\'."<<endr;
    if(!writer.write(*myPositions))
      report << error << "Could not write "<<getId()<<" \'"<<myFilename<<"\'."<<endr;    
  }

  Output* OutputFinalXYZBinPos::doMake(string&, const vector<Value>& values) const{
    return (new OutputFinalXYZBinPos(values[0]));
  }

  void OutputFinalXYZBinPos::getParameters(vector<Parameter> &parameter) const{
    parameter.push_back(Parameter(getId(),Value(myFilename,ConstraintValueType::NotEmpty())));
  }

}
