#include "OutputFinalXYZPos.h"
#include "Configuration.h"
#include "OutputCache.h"
#include "stringutilities.h"
#include "GenericTopology.h"
#include "XYZWriter.h"
using namespace ProtoMol::Report;

using std::string;
using std::vector;

namespace ProtoMol {
  //________________________________________________________ OutputFinalXYZPos
  const string  OutputFinalXYZPos::keyword("finXYZPosFile");

  OutputFinalXYZPos::OutputFinalXYZPos():Output(1),myFilename(""){}

  OutputFinalXYZPos::OutputFinalXYZPos(const string& filename):Output(1),myFilename(filename){}

  void OutputFinalXYZPos::doFinalize(int step){
    XYZWriter writer;
    if(!writer.open(myFilename))
      report << error << "Can't open "<<getId()<<" \'"<<myFilename<<"\'."<<endr;
    writer.setComment("Time : "+toString(myCache->time())+", step : "+toString(step)+".");
    if(!writer.write(*myPositions,myTopology->atoms,myTopology->atomTypes))
      report << error << "Could not write "<<getId()<<" \'"<<myFilename<<"\'."<<endr;    
  }

  Output* OutputFinalXYZPos::doMake(string&, const vector<Value>& values) const{
    return (new OutputFinalXYZPos(values[0]));
  }

  void OutputFinalXYZPos::getParameters(vector<Parameter> &parameter) const{
    parameter.push_back(Parameter(getId(),Value(myFilename,ConstraintValueType::NotEmpty())));
  }

}
