/*  -*- c++ -*-  */
#ifndef INPUTVALUEDEFINITIONS_H
#define INPUTVALUEDEFINITIONS_H

#include "InputValue.h"

namespace ProtoMol {


  //________________________________________________________ InputValue<>

  declareInputValue(InputOutput,BOOL,NOCONSTRAINTS);
  declareInputValue(InputDebug,INT,NOCONSTRAINTS);
  declareInputValue(InputTemperature,REAL,NOTNEGATIVE);
  declareInputValue(InputSeed,INT,NOTNEGATIVE);
  declareInputValue(InputConfig,STRING,NOTEMPTY);
  declareInputValue(InputFirststep,INT,NOCONSTRAINTS);
  declareInputValue(InputNumsteps,INT,NOTNEGATIVE);
  declareInputValue(InputOutputfreq,INT,NOTNEGATIVE);
  declareInputValue(InputIntegrator,INTEGRATOR,NOTEMPTY);
  declareInputValue(InputPositions,STRING,NOTEMPTY);
  declareInputValue(InputVelocities,STRING,NOTEMPTY);
  declareInputValue(InputPSF,STRING,NOTEMPTY);
  declareInputValue(InputPAR,STRING,NOTEMPTY);
  declareInputValue(InputRemoveLinearMomentum,INT,NOCONSTRAINTS);
  declareInputValue(InputRemoveAngularMomentum,INT,NOCONSTRAINTS);
  declareInputValue(InputUseBarrier,BOOL,NOCONSTRAINTS);
  declareInputValue(InputParallelPipe,INT,NOCONSTRAINTS);
  declareInputValue(InputParallelMode,STRING,NOTEMPTY);
  declareInputValue(InputMaxPackages,INT,NOCONSTRAINTS);
  declareInputValue(InputPDBScaling,BOOL,NOCONSTRAINTS);
  declareInputValue(InputBoundaryConditions,STRING,NOTEMPTY);
  declareInputValue(InputCellManager,STRING,NOTEMPTY); 
  declareInputValue(InputDihedralMultPSF,BOOL,NOCONSTRAINTS);
  declareInputValue(InputVirialCalc,BOOL,NOCONSTRAINTS);
  declareInputValue(InputMolVirialCalc,BOOL,NOCONSTRAINTS);
  declareInputValue(InputShake,BOOL,NOCONSTRAINTS);
  declareInputValue(InputShakeEpsilon,REAL,NOTNEGATIVE);
  declareInputValue(InputShakeMaxIter,INT,NOTNEGATIVE);
  declareInputValue(InputRattle,BOOL,NOCONSTRAINTS);
  declareInputValue(InputRattleEpsilon,REAL,NOTNEGATIVE);
  declareInputValue(InputRattleMaxIter,INT,NOTNEGATIVE);
  declareInputValue(InputReducedImage,BOOL,NOCONSTRAINTS);  
}

#endif
