#include "ImpulseIntegrator.h"

using std::vector;
using std::string;

namespace ProtoMol {
  //_________________________________________________________________ ImpulseIntegrator
  const string ImpulseIntegrator::keyword("Impulse");

  ImpulseIntegrator::ImpulseIntegrator():MTSIntegrator(){}

  ImpulseIntegrator::ImpulseIntegrator(int cycles, 
				       ForceGroup *overloadedForces,
				       StandardIntegrator *nextIntegrator) :
    MTSIntegrator(cycles, overloadedForces, nextIntegrator) {

  }

  void ImpulseIntegrator::initialize(GenericTopology *topo, Vector3DBlock
				     *positions, Vector3DBlock *velocities, ScalarStructure *energies) {
    MTSIntegrator::initialize(topo, positions, velocities, energies);
    initializeForces();
  }

  MTSIntegrator* ImpulseIntegrator::doMake(string&, const vector<Value>& values,ForceGroup* fg, StandardIntegrator *nextIntegrator)const{
    return new ImpulseIntegrator(values[0],fg,nextIntegrator);
  }
}
