/*  -*- c++ -*-  */
#ifndef MODIFIERUPDATEBETAANDPUSH_H
#define MODIFIERUPDATEBETAANDPUSH_H

#include "Modifier.h"
#include "ShadowHMCIntegrator.h"

namespace ProtoMol {

  //_________________________________________________________________ ModifierUpdateBetaAndPush
  class ModifierUpdateBetaAndPush : public Modifier {
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // Constructors, destructors, assignment
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  public:
    ModifierUpdateBetaAndPush(ShadowHMCIntegrator* i):Modifier(Constant::MAX_INT-100),myTheIntegrator(i){}

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // From class Modifier
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  public:
    virtual bool isInternal() const {return true;}
  private:
    virtual void doExecute(){
      myTheIntegrator->updateBeta();
      myTheIntegrator->pushShadowHistory();
    }
    virtual std::string doPrint()const{return std::string("UpdateBetaAndPush");};

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // My data members
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  private:
    ShadowHMCIntegrator* myTheIntegrator;
  };

}
#endif /* MODIFIER_H */
