#include "AngleInfo.h"

namespace ProtoMol{
  AngleInfo::AngleInfo() {
    m_angle = 0.0;
    m_pointer = 0;
    m_angleType = ANGLE_NOTSET;
    m_visited = false;
    m_isExclusionAtom = false;
    m_isInnerAtom = false;
    m_atomID = 0;
  }

  AngleInfo::~AngleInfo() {
  }


  void AngleInfo::setAtomID(unsigned int ID) {
    m_atomID = ID;
  }

  unsigned int AngleInfo::getAtomID() const{
    return m_atomID;
  }   

  void AngleInfo::addBond(int atom) {
    m_bondedAtoms.push_back(atom);
  }

  void AngleInfo::setAngle(Real angle) {
    m_angle = angle;
    m_angleType = ANGLE_VALUE;
  }

  void AngleInfo::setPointer(unsigned int atom) {
    m_pointer = atom;
    m_angleType = ANGLE_POINTER;
  }

  unsigned int AngleInfo::getAngleType()const {
    return m_angleType;
  }

  Real AngleInfo::getAngle()const {
    return m_angle;
  }

  unsigned int AngleInfo::getPointer() const{
    return m_pointer;
  }

  void AngleInfo::setVisited() {
    m_visited = true;
  }


  bool AngleInfo::isVisited() const{
    return m_visited;
  }


  void AngleInfo::setInnerAtom(){
    m_isInnerAtom = true;
  }


  bool AngleInfo::isInnerAtom() const {
    return m_isInnerAtom;
  }

  void AngleInfo::setExclusionAtom() {
    m_isExclusionAtom = true;
  }

  bool AngleInfo::isExclusionAtom()  const{
    return m_isExclusionAtom;
  }

  unsigned int AngleInfo::numBonds()const {
    return m_bondedAtoms.size();

  }

  unsigned int AngleInfo::getBond(unsigned int index) const{
    if (index < m_bondedAtoms.size()) {
      return m_bondedAtoms[index];
    }
    return 0;
  }
}
