/* -*- c++ -*- */
#ifndef ANGLEINFO_H
#define ANGLEINFO_H

#include <vector>
#include "Real.h"

namespace ProtoMol {
  /**
     No comment Cplt!
  */
  class AngleInfo {
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // Enums & types
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  public:
    enum { ANGLE_VALUE  =    10001,
	   ANGLE_POINTER =   10002,
	   ANGLE_NOTSET =    10003,      
	   VISITED     =     10001,
	   NOT_VISITED =     10002};

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // Constructors, destructors, assignment
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  public:
    AngleInfo();
    ~AngleInfo();

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // New methods of class CubicCellManager
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 public:
    void addBond(int atom);
    void setAngle(Real angle);
    void setPointer(unsigned int atom);
    void setExclusionAtom();
    void setInnerAtom();
    void setVisited();
    void setAtomID(unsigned int ID);
    unsigned int getAngleType() const;
    unsigned int getBond(unsigned int index) const;
    unsigned int numBonds() const;
    unsigned int getAtomID() const;
    Real getAngle() const;
    unsigned int getPointer() const;
    bool isExclusionAtom() const;
    bool isInnerAtom() const;
    bool isVisited() const;
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // My data members
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  private:
    Real m_angle;
    unsigned int m_atomID;
    unsigned int m_pointer;
    unsigned int m_angleType;
    bool m_visited;
    bool m_isExclusionAtom;
    bool m_isInnerAtom;
    std::vector<unsigned int> m_bondedAtoms;
  };

}
#endif
